function grad = getgrad(x,method,lambda)
  p = length(x);
  if method == 0
      id  = find(x);
      if isempty(id)
        grad =  lambda*ones(p,1);
      else
       grad = lambda* 1./(abs(x)+1e-15);
      end
  elseif 0 < method && method < 1
      tau = method;
      id  = find (x);
      if isempty(id)
        grad =  lambda*ones(p,1);
      else
        grad = lambda*tau*(abs(x)+1e-15).^(tau-1);
      end
  elseif method == 1
      grad = lambda*ones(p,1);
  elseif method == 2
       tau = 3.7;
       grad = zeros(p,1);
       id = find(abs(x)<=lambda);
       grad(id) = lambda*ones(length(id),1);
       id1 = find(abs(x)<lambda*tau);
       id2 = find(abs(x)>lambda);
       id = intersect(id1,id2);
       grad(id) = (lambda*tau-abs(x(id)))/(tau-1);
  elseif method == 3
        tau = 2.7;
        grad = zeros(p,1);
        id = find(abs(x)<=lambda*tau);
        grad(id) = lambda*ones(length(id),1)-abs(x(id))/tau;
  elseif method == 4
        tau = 1.5;
        grad = zeros(p,1);
        id = find(abs(x)<=lambda*tau);
        grad(id) = lambda*ones(length(id),1);  
  end