function opts = set_pdasopts(method)
%------------------------------------------------------------------------%
% set default parameters for pdas continuation step                      %
% (c) by Yuling Jiao (yulingjiaomath@whu.edu.cn)                         %
%         Bangti Jin (bangti.jin@gmail.com)                              %
% Created on March 17, 2013                                              %
%------------------------------------------------------------------------%
if isempty(method)
    method = 'l0';
end
opts.method= method;
opts.alpha = 0;      % if X is highly coorelated, set it to be a small number. 
opts.N     = 100;    % you can set it smaller to make the algorithm faster
opts.Lmin  = 1e-15;  % depend on noise level, we set 1e-15 may suit all noise
opts.Lmax  = 1;
opts.MaxIt = 5;      % you can set to be 1, make it faster 
opts.mu    = 0.5;    % if the target sparsity level larger than 0.5n,  just set this to be 1;
switch method        % opts.tau is not sensitive at all 
    case 'l0'
        opts.tau = [];
    case 'bridge'
        opts.tau = 0.5;    
    case 'scad'
        opts.tau = 3.7;
    case 'mcp'
        opts.tau = 2.7;
    case 'cl1'
        opts.tau = 1.5;
    otherwise
        error('Undefined method in pdas!')
end