
clc
clear all 
close all
addpath(genpath(fileparts(mfilename('fullpath'))));
warning off 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        Data Generation Setting 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p = 1000;           % length of underlyling solution  
n = 500;            % number of samples 
cor = 0;            % corelation number of columns in X 
ratio = 3;          % range of value in betatrue = 10^ratio;
isnorm = 1;         % 1 normlized; 0 not
seednum = 0;        % the seed number 
sigma = 1e-2;       % varince of the  noise 
kind = 1;           % kind = 1 is the setting  of standard CS 
s = 1;
%%
N = 10:10:300;
len = length(N);
maxnumtest = 50;                              % number of replecations  
Method = [0,0.5,1,2,3,4];                     % type of method concerned here. 1_0,l_0.5,l_1,SDCA,MCP,Capped-l_1;
nmethod = length(Method);
Scputime = zeros(maxnumtest,len,nmethod);     
Srel2error = zeros(maxnumtest,len,nmethod);     
Sabslinferror = zeros(maxnumtest,len,nmethod);
Sstopiternum = zeros(maxnumtest,len,nmethod); 
Ssignificant = zeros(maxnumtest,len,nmethod); 
Sexact  = zeros(maxnumtest,len,nmethod);  
 
for k = 1:len
    K = N(k); 
    for l = 1:maxnumtest
       %% Generate data 
        seednum = seednum  + k*l;
        [nPsi,D,y,ye,xtrue,supp] = gendata2(n,p,K,sigma,cor,ratio,seednum,isnorm,kind,s);
%            [nPsi,y,ye,xtrue,supp]=gendata(n,p,K,sigma,ratio,seednum,kind,cor);
%            D = 1;
        noiselev = norm(y-ye);
        % Set parameter in UPDAS 
               opts.N = 100;                    % the size of Lambda 
               opts.Lamend = 1e-10;             % the minimun in Lambda
               opts.Maxiter = 5;               % maximum number of iteration in UPDAS
               opts.noiselev = norm(y-ye);      % stop when ||residual||<= opts.noiselev 
               opts.mu = 0.8;                   % stop  when ||x_{lambda_{k}}||> opts.mu*n 
               opts.initial = zeros(p,1);       % initial value for UPDAS 
               opts.alpha = 0;
               opts.testkind = 1;
        for mm = 1:nmethod
            method = Method(mm);
           if method == 0                    
            % UPDAS l_0
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(l_0)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_0time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = l_0time;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,k,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           elseif method == 0.5                    
            % UPDAS l_0.5
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(l_0.5)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0.5')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_halftime = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = l_halftime;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,k,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           elseif method == 1 % PFBS   WITH CONTINUATION      
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %                     PFBS(l_1)
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           disp('PFBS l_{1} is runing....')
          %% Precompute  and Set parameters in Algorithm PFBS
           opt.N = 200;            % the size of Lambda (defaut: 100) 
           opt.tau = 1e-10;        % opts.stop, stoping rule for relative change
           opt.stop = 1e-7; 
           opt.J = 5*n;            % maxiteration number in CD    (defaut: 5*n)
           opt.mu = 0.5;           % stop  when ||beta^k||_0 >mu*n  (defaut: 0.5)
           opt.normnX = norm(nPsi);        
           opt.lemend = 1e-10;
           opt.alpha = 0;
           opt.initial  = zeros(p,1);% initial value 
          %% Approximate the Whole Path by Coordinate Descent         
           tic,
           [ex, elambda, Hisex, Hisacsize, Hisiter, Bic] = pfbsl1path(nPsi,y,opt);
           ex = D*ex;
           l1time = toc
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = l1time;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,k,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           elseif method == 2                    
            % UPDAS SCAD
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(SCAD)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('SCAD is running')
               
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               scadtime = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = scadtime;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,k,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           elseif method == 3                    
            % UPDAS MCP
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(MCP)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, MCP')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               mcptime = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = mcptime;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           
           elseif method == 4                    
            % UPDAS Capped-l_1
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(Capped-l_1)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, Capped-l_1')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               capl1time = toc
               opts.alpha = 0;
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,k,mm) = capl1time;  
            Srel2error(l,k,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,k,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,k,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,k,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,k,mm) = 1; 
               end
           end
           end
        end
    end
end
%% Compute average performance 
averagetime = mean(Scputime);
stdtime = std(Scputime);
averagestopiternum = mean(Sstopiternum);
stdstopiternum = std(Sstopiternum);
averagerel2error = mean(Srel2error);
stdl2error = std(Srel2error);
averageabslinferror = mean(Sabslinferror);
stdabslinferror = std(Sabslinferror);
proboracle = mean(Sexact);
probsignif = mean(Ssignificant);
%% save result 
%save sparsitylevelupdas
%% plot results 
figure(1),
prob = [proboracle(:,:,1);proboracle(:,:,2);proboracle(:,:,3);proboracle(:,:,4);proboracle(:,:,5);proboracle(:,:,6)]';
plot(N,prob(:,1),'kd-',N,prob(:,2),'b*:',N,prob(:,3),'ro--',N,prob(:,4),'y+-',N,prob(:,5),'gs:',N,prob(:,6),'c.-.','LineWidth',2)
xlabel(' Sparsity level ')
h = xlabel('Sparsity level');
set(gca,'xtick',50:50:300)
set(h,'Interpreter','latex','fontsize',16)
h = ylabel('Probability of exact recover of  true support');
set(h,'Interpreter','latex','fontsize',16)
h = legend('$\ell^{0}$','$\ell^{1/2}$','$\ell^{1}$','SCAD','MCP','Capped-$\ell^{1}$',6);
set(h,'Interpreter','latex','fontsize',16)
axis([0 1.2*max(N) -0.2 1.5])

