clc
clear all
close all
lambda = 1.2;
x = (-5:0.01:5)';
%% l_0
thl0 = x;
x1 = [(-5:0.01:-0.15)';(0.15:0.01:5)'];
fl0 = lambda*ones(size(x1)); 
id = find(abs(x)<=(2*lambda)^0.5);
thl0(id) =  zeros(length(id),1);
figure(1)
plot(x1,fl0,'r.','LineWidth',2)
hold on
plot(0,lambda,'bo','LineWidth',1.5)
hold on 
plot(0,0,'r*','LineWidth',3)
hold off
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0 1.1*max(abs(fl0))])
set(gca,'xtick',0:5:5), axis square
filename = 'pl0';
print(1, '-depsc',filename)
print(1, '-dpng', filename)
saveas(1, filename, 'fig')
figure(2),
plot(x,thl0,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thl0';
print(2, '-depsc',filename)
print(2, '-dpng', filename)
saveas(2, filename, 'fig')
%% l_0.5
tau = 0.5;
flhalf = (abs(x)).^(0.5);
thlhalf = ones(length(x),1);
id = find(abs(x)<(2-tau)*(2*(1-tau))^((tau-1)/(2-tau)));
thlhalf(id) =  zeros(length(id),1);
id = find(x>=(2-tau)*(2*(1-tau))^((tau-1)/(2-tau)));
for k = 1: length(id)
    c = [1,0,-x(id(k)),1/2];
    r = roots(c);
   th = r(2)^2;
    thlhalf(id(k))=th;
end

idd = find(x<=-(2-tau)*(2*(1-tau))^((tau-1)/(2-tau)));
thlhalf(idd)= -thlhalf(id(end:-1:1));
figure(3)
plot(x,flhalf,'r-','LineWidth',2)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0 1.1*max(abs(flhalf))])
set(gca,'xtick',0:5:5), axis square
filename = 'plhalf';
print(3, '-depsc',filename)
print(3, '-dpng', filename)
saveas(3, filename, 'fig')
figure(4)
plot(x,thlhalf,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thlhalf';
print(4, '-depsc',filename)
print(4, '-dpng', filename)
saveas(4, filename, 'fig')
%% SCAD
tau = 3.7;
fscad = ones(length(x),1)*lambda^2*(tau+1)/2;
thscad = x;
id = find(abs(x)<=lambda);
fscad(id) = lambda*abs(x(id));
thscad(id) = zeros(length(id),1);
id1 = find(abs(x)<= tau*lambda);
id2 = find(abs(x)>lambda);
id = intersect(id1,id2);
fscad(id) = (lambda*tau*abs(x(id))-(x(id).^2+lambda^2)/2)/(tau-1);
id1 = find(abs(x)<= 2*lambda);
id2 = find(abs(x)>lambda);
id = intersect(id1,id2);
thscad(id) =  max(abs(x(id))-lambda,0).*sign(x(id));
id1 = find(abs(x)<= tau*lambda);
id2 = find(abs(x)>2*lambda);
id = intersect(id1,id2);
thscad(id) =  max(abs(x(id))-lambda*tau/(tau-1),0)/(1-1/(tau-1)).*sign(x(id));
figure(5)
plot(x,fscad,'r-','LineWidth',2)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0 1.1*max(abs(fscad))])
set(gca,'xtick',0:5:5), axis square
filename = 'pscad';
print(5, '-depsc',filename)
print(5, '-dpng', filename)
saveas(5, filename, 'fig')
figure(6)
plot(x,thscad,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thscad';
print(6, '-depsc',filename)
print(6, '-dpng', filename)
saveas(6, filename, 'fig')
%% MCP
tau = 2.7;
fmcp = ones(length(x),1)*lambda^2*tau/2;
thmcp = x;
id = find(abs(x)<=tau*lambda);
fmcp(id) = lambda*abs(x(id))-x(id).^2/(2*tau);
thmcp(id) =  max(abs(x(id))-lambda,0)/(1-1/tau).*sign(x(id));
figure(7)
plot(x,fmcp,'r-','LineWidth',2)
 xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0 1.1*max(abs(fmcp))])
set(gca,'xtick',0:5:5), axis square
filename = 'pmcp';
print(7, '-depsc',filename)
print(7, '-dpng', filename)
saveas(7, filename, 'fig')
figure(8)
plot(x,thmcp,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thmcp';
print(8, '-depsc',filename)
print(8, '-dpng', filename)
saveas(8, filename, 'fig')
%% capped-l1
tau = 1.5;
fcap = ones(length(x),1)*lambda^2*tau;
thcap = x;
id = find(abs(x)<=tau*lambda);
fcap(id) = lambda*abs(x(id));
id = find(abs(x)<=lambda);
thcap(id) = zeros(length(id),1);
id1 = find(abs(x)<= (tau+0.5)*lambda);
id2 = find(abs(x)>lambda);
id = intersect(id1,id2);
thcap(id) =  max(abs(x(id))-lambda,0).*sign(x(id));
figure(9)
plot(x,fcap,'r-','LineWidth',2)
 xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0  1.1*max(abs(fcap))])
set(gca,'xtick',0:5:1.1*max(abs(fcap))), axis square
filename = 'pcl1';
print(9, '-depsc',filename)
print(9, '-dpng', filename)
saveas(9, filename, 'fig')
figure(10)
plot(x,thcap,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thcl1';
print(10, '-depsc',filename)
print(10, '-dpng', filename)
saveas(10, filename, 'fig')
%% l1
fl1 = abs(x);
thl1 =  max(abs(x)-lambda,0).*sign(x);
figure(11)
plot(x,fl1,'r-','LineWidth',2)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',0:5:5)
axis([-5 5 0  1*max(abs(fl1))])
set(gca,'xtick',0:5:5), axis square
filename = 'pl1';
print(11, '-depsc',filename)
print(11, '-dpng', filename)
saveas(11, filename, 'fig')
figure(12)
plot(x,thl1,'b--.','LineWidth',1)
xlabel('t','fontsize',30); set(gca,'fontsize',30), set(gca,'ytick',-5:5:5)
axis([-5 5 -5 5])
set(gca,'xtick',-5:5:5), axis square
filename = 'thl1';
print(12, '-depsc',filename)
print(12, '-dpng', filename)
saveas(12, filename, 'fig')