

clc
clear all 
close all
addpath(genpath(fileparts(mfilename('fullpath'))));
warning off 
mex proximalRegC.c
mex funRegC.c
%%
len = 3;              % type of dataset 
nmethod = 5;          % type of method to compared. Lasso, MCP, SDCA
maxnumtest = 10;                          
Scputime = zeros(maxnumtest,len,nmethod);     
Srel2error = zeros(maxnumtest,len,nmethod);     
Sabslinferror = zeros(maxnumtest,len,nmethod);
Sover  = zeros(maxnumtest,len,nmethod);  
Saclen = zeros(maxnumtest,len,nmethod);
Sunder = zeros(maxnumtest,len,nmethod);
Cor  = [0, 0, 0.2];
seednum = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        Data Generation Setting 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k = 1:len
        cor =   Cor(k);
        opts.N = 100;                    % the size of Lambda 
        opts.Lamend = 1e-15;             % the minimun in Lambda
        if k == 2
           opts.mu = 1;
        else
           opts.mu = 0.5;                % stop  when ||x_{lambda_{k}}||> opts.mu*n 
        end 
  for l = 1:maxnumtest
        %% Generate data 
        seednum = seednum  + k*l;
        if k ==1
            p = 10000;          % length of underlyling solution  
            n = 500;            % number of samples 
            ratio = 3;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 0.5e0;      % varince of the  noise 
            kind = 1;           % kind = 1 is the setting  of standard CS 
            K = 50;             % number of nonzero elements 
        elseif k==2
            p = 50;             % length of underlyling solution  
            n = 50;             % number of samples 
            ratio = 2;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 1e-2;      % varince of the  noise 
            kind = 2;           % kind = 1 is the setting  of standard CS 
            K = 5;              % number of nonzero elements 
        else
            p = 10000;          % length of underlyling solution  
            n = 1000;           % number of samples 
            ratio = 3;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 0.50;      % varince of the  noise 
            kind = 3;           % kind = 1 is the setting  of standard CS 
            K = 100;            % number of nonzero elements         
        end
        [X,D,y,ye,xe,Ae] = gendata(n,p,K,sigma,ratio,seednum,kind,cor);    
        noiselev = norm(y-ye);
        opts.noiselev = norm(y-ye);      %  stop when ||residual||<= opts.noiselev 
        opts.Lamend = 1e-15;             % the minimun in Lambda
     for method = 1:5
            
         if method == 1
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    Gista-l0
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('Gista-l0 is runing....')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathgista(X,y,2,opts);
               l_0time = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = l_0time;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
           Sunder(l,k,method) = length(setdiff(Ae,esupp));
           Sover(l,k,method) = length(setdiff(esupp,Ae)); 
          elseif method == 2 
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    Gista-lhalf
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('Gista-lhalf is runing....')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathgista(X,y,2,opts);
               l_harftime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = l_harftime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
           Sunder(l,k,method) = length(setdiff(Ae,esupp));
           Sover(l,k,method) = length(setdiff(esupp,Ae)); 
         elseif method == 3             
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    Gista-scad
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('Gista-scad is runing....')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathgista(X,y,3,opts);
               scadtime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = scadtime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
           Sunder(l,k,method) = length(setdiff(Ae,esupp));
           Sover(l,k,method) = length(setdiff(esupp,Ae)); 
         elseif method == 4  
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    Gista-mcp
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('Gista-mcp is runing....')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathgista(X,y,4,opts);
               mcptime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = mcptime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
           Sunder(l,k,method) = length(setdiff(Ae,esupp));
           Sover(l,k,method) = length(setdiff(esupp,Ae)); 
         else 
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    Gista-cl1
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('Gista-cl1 is runing....')
               tic,
              [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathgista(X,y,2,opts);
               cl1time = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = cl1time;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
           Sunder(l,k,method) = length(setdiff(Ae,esupp));
           Sover(l,k,method) = length(setdiff(esupp,Ae));    
         end                     
      end
   end
end
%% save result 
save gista
%% Compute average performance 
averagetime = mean(Scputime);
stdtime = std(Scputime);
averagerel2error = mean(Srel2error);
stdl2error = std(Srel2error);
averageabslinferror = mean(Sabslinferror);
stdabslinferror = std(Sabslinferror);
averageover = mean(Sover);
averageunder = mean(Sunder);
time = [averagetime(:,:,1);averagetime(:,:,2);averagetime(:,:,3);averagetime(:,:,4);averagetime(:,:,5)]
linferror = [averageabslinferror(:,:,1);averageabslinferror(:,:,2);averageabslinferror(:,:,3);averageabslinferror(:,:,4);averageabslinferror(:,:,5)]
l2error = [averagerel2error(:,:,1);averagerel2error(:,:,2);averagerel2error(:,:,3);averagerel2error(:,:,4);averagerel2error(:,:,5)]
