

clc
clear all 
close all
addpath(genpath(fileparts(mfilename('fullpath'))));
warning off 
%%
len = 3;              % type of dataset 
nmethod = 5;          % type of method to compared. Lasso, MCP, SDCA
maxnumtest = 10;                          
Scputime = zeros(maxnumtest,len,nmethod);     
Srel2error = zeros(maxnumtest,len,nmethod);     
Sabslinferror = zeros(maxnumtest,len,nmethod);
Cor  = [0, 0, 0.2];
seednum = 0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        Data Generation Setting 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k = 1:len
       cor =   Cor(k);
       
    for l = 1:maxnumtest
        %% Generate data 
        seednum = seednum +k*l;
        if k ==1
            p = 10000;          % length of underlyling solution  
            n = 500;            % number of samples 
            ratio = 3;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 0.50;      % varince of the  noise 
            kind = 1;           % kind = 1 is the setting  of standard CS 
            K = 50;            % number of nonzero elements 
        elseif k==2
            p = 50;             % length of underlyling solution  
            n = 50;             % number of samples 
            ratio = 2;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 1e-2;       % varince of the  noise 
            kind = 2;           % kind = 1 is the setting  of standard CS 
            K = 5;              % number of nonzero elements 
        elseif k==3
            p =10000;           % length of underlyling solution  
            n = 1000;           % number of samples 
            ratio = 3;          % range of value in betatrue = 10^ratio;
            isnorm = 1;         % 1 normlized; 0 not
            sigma = 0.50;       % varince of the  noise 
            kind = 3;           % kind = 1 is the setting  of standard CS 
            K = 100;            % number of nonzero elements         
        end
     [X,D,y,ye,xe,Ae] = gendata(n,p,K,sigma,ratio,seednum,kind,cor);    
     for method = 1:5
         if method ==1
             mmethod = 'l0';    
         elseif method  == 2     
             mmethod = 'bridge';
         elseif method ==3
            mmethod = 'scad';
         elseif method == 4
            mmethod = 'mcp';
         else
            mmethod = 'cl1';
         end
         opts = set_pdasopts(mmethod); 
         opts.del = norm(y-ye);      %  stop when ||residual||<= opts.noiselev
          if k == 2
             opts.mu = 1;
          else
             opts.mu = 0.5;
          end
          
         if method == 1
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    PDAS-l0
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('PDAS-l0 is runing....')
               tic,
%                [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(X,y,0,opts);
               [ex,lam,ithist] = pdas_path(X,y,opts);
               l_0time = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = l_0time;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
           esupp = find (ex);
          elseif method == 2 
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    PDAS-lhalf
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('PDAS-lhalf is runing....')
               tic,
              [ex,lam,ithist] = pdas_path(X,y,opts);
               l_harftime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = l_harftime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
         elseif method == 3             
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    PDAS-scad
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('PDAS-scad is runing....')
               tic,
               [ex,lam,ithist] = pdas_path(X,y,opts);
               scadtime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = scadtime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
         elseif method == 4  
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    PDAS-mcp
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('PDAS-mcp is runing....')
               tic,
               [ex,lam,ithist] = pdas_path(X,y,opts);
               mcptime = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = mcptime;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
         else 
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                    PDAS-cl1
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                    %% Approximate the Whole Path 
            disp('PDAS-cl1 is runing....')
               tic,
               [ex,lam,ithist] = pdas_path(X,y,opts);
               cl1time = toc
               ex = D*ex;  
                  %% store error, cputime, 
           Scputime(l,k,method) = cl1time;  
           Srel2error(l,k,method) =  norm(ex - xe)/norm(xe);     
           Sabslinferror(l,k,method) = norm(ex - xe,inf);
         end                     
      end
   end
end
%% save result 
% save pdas
%% Compute average performance 
averagetime = mean(Scputime);
stdtime = std(Scputime);
averagerel2error = mean(Srel2error);
stdl2error = std(Srel2error);
averageabslinferror = mean(Sabslinferror);
stdabslinferror = std(Sabslinferror);
time = [averagetime(:,:,1);averagetime(:,:,2);averagetime(:,:,3);averagetime(:,:,4);averagetime(:,:,5)]
linferror = [averageabslinferror(:,:,1);averageabslinferror(:,:,2);averageabslinferror(:,:,3);averageabslinferror(:,:,4);averageabslinferror(:,:,5)];
l2error = [averagerel2error(:,:,1);averagerel2error(:,:,2);averagerel2error(:,:,3);averagerel2error(:,:,4);averagerel2error(:,:,5)]
