
clc
clear all 
close all
addpath(genpath(fileparts(mfilename('fullpath'))));
warning off 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        Data Generation Setting 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
p = 1000;           % length of underlyling solution  
n = 400;            % number of samples 
K = 50;             % number of nozero elements
cor = 0;            % corelation number of columns in X 
ratio = 3;          % range of value in betatrue = 10^ratio;
isnorm = 1;         % 1 normlized; 0 not
seednum = 0;        % the seed number 
sigma = 0.5;        % varince of the  noise 
kind = 1;           % kind = 1 is the setting  of standard CS 
s = 1;
%%
maxnumtest = 10;                        % number of replecations  
Method = 0:0.2:0.8;                     % type of method concerned here. 1_0,l_0.2,1_4,l_0.6,1_0.8,l_1;
nmethod = length(Method);
Scputime = zeros(maxnumtest,nmethod);     
Srel2error = zeros(maxnumtest,nmethod);     
Sabslinferror = zeros(maxnumtest,nmethod);
Sstopiternum = zeros(maxnumtest,nmethod); 
Ssignificant = zeros(maxnumtest,nmethod); 
Sexact  = zeros(maxnumtest,nmethod);  

    for l = 1:maxnumtest
       %% Generate data 
        seednum = seednum  + l;
        %[nPsi,D,y,ye,xtrue,supp] = gendata2(n,p,K,sigma,cor,ratio,seednum,isnorm,kind,s);
      [nPsi,D,y,ye,xtrue,supp]=gendata(n,p,K,sigma,ratio,seednum,kind,cor);
        noiselev = norm(y-ye);
        % Set parameter in UPDAS 
               opts.N = 100;                    % the size of Lambda 
               opts.Lamend = 1e-10;             % the minimun in Lambda
               opts.Maxiter = 10;               % maximum number of iteration in UPDAS
               opts.noiselev = norm(y-ye);      %  stop when ||residual||<= opts.noiselev 
               opts.mu = 0.5;                   % stop  when ||x_{lambda_{k}}||> opts.mu*n 
               opts.initial = zeros(p,1);       % initial value for UPDAS 
               opts.alpha = 0;
               opts.testkind = 1;
        for mm = 1:nmethod
            method = Method(mm)
           if method == Method(1)                    
            % UPDAS l_0
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(l_0)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_0time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,mm) = l_0time;  
            Srel2error(l,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,mm) = 1; 
               end
           end
           elseif method == Method(2)                   
            % UPDAS l_0.2
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS(l_0.2)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0.2')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_02time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,mm) = l_02time;  
            Srel2error(l,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,mm) = 1; 
               end
           end
           elseif method == Method(3) % 
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS (l_0.4)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0.4')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_04time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,mm) = l_04time;  
            Srel2error(l,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,mm) = 1; 
               end
           end
          elseif method == Method(4) % 
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS (l_0.6)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0.6')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_06time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,mm) = l_06time;  
            Srel2error(l,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,mm) = 1; 
               end
           end
           elseif method == Method(5) % 
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            %                     UPDAS (l_0.8)
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
           %% Approximate the Whole Path 
               disp('UPDAS, l_0.8')
               tic,
               [ex, elambda, Hisx, Hisacsize, Hisiter,Hisresidual,Bic] = pathdiscnonconvex(nPsi,y,method,opts);
               l_08time = toc
               ex = D*ex;    
           %% store error, cputime, number of iterations, number of exact
           %% recover 
            Scputime(l,mm) = l_08time;  
            Srel2error(l,mm) =  norm(ex - xtrue)/norm(xtrue);     
            Sabslinferror(l,mm) = norm(ex - xtrue,inf);
            Sstopiternum (l,mm) =  sum(Hisiter); 
            esupp = find (ex);
            if isempty(setdiff(supp,esupp))
               Ssignificant(l,mm) = 1;
            end
           if length(esupp) == length(supp)
               if esupp == supp
                   Sexact(l,mm) = 1; 
               end
           end      
           end
        end
    end

%% Compute average performance 
averagetime = mean(Scputime)'
stdtime = std(Scputime);
averagestopiternum = mean(Sstopiternum);
stdstopiternum = std(Sstopiternum);
averagerel2error = mean(Srel2error)'
stdl2error = std(Srel2error);
averageabslinferror = mean(Sabslinferror)'
stdabslinferror = std(Sabslinferror);
proboracle = mean(Sexact);
probsignif = mean(Ssignificant);
%% save result 
% save l_qonly

